function dataHandler(val, oldVal) {
  console.log('comparison:', val === oldVal);

  if (!oldVal) {
    this.renderChart(this.chartData, this.options);
  } else {
    var updateData = val.datasets.some(function (dataset, i) {
      if (dataset.data.length !== oldVal.datasets[i].data.length) return true;
      return dataset.data.some(function (value, j) {
        console.log(value, oldVal.datasets[i].data[j]);
        return value !== oldVal.datasets[i].data[j];
      });
    });
    var updateLabels = val.labels.length !== oldVal.labels.length || val.labels.some(function (label, i) {
      return label !== oldVal.labels[i];
    });

    if (updateData || updateLabels) {
      console.log('updating...');

      this.$data._chart.update();
    }
  }
}

export var reactiveData = {
  data: function data() {
    return {
      chartData: null
    };
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
};
export var reactiveProp = {
  props: {
    chartData: {
      required: true
    }
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
};
export default {
  reactiveData: reactiveData,
  reactiveProp: reactiveProp
};